/* 
CREATE TABLE  `Stats` (
 `User` VARCHAR( 33 ) NOT NULL ,
 `Kills` INT( 9 ) UNSIGNED NOT NULL ,
UNIQUE (
`User`
)
) ENGINE = MYISAM ;
*/

#include < amxmodx >
#include < sqlx >
#pragma semicolon 1

new KillsCount[ 33 ];
new gPlayerAuthid[ 33 ][ 64 ];
new gPlayerConnected;

#define USING_CUSTOM_MOTD

enum 
{
	SAVING = 1,
	STATS,
	LOAD,
	
	NULL
}

new ePlayerData[ 33 ];

new Handle:g_hTuple;

new bool:isValidMap = true;

new iMaxPlayers;

#define SetBit(%1) |= ( 1 << ( %1 % iMaxPlayers ) )
#define RemBit(%1) &= ~( 1 << ( %1 % iMaxPlayers ) )
#define HasBit(%1) & ( 1 << ( %1 % iMaxPlayers ) )

#define SetDefaultValue(%0) (KillsCount[ %0 ] = 0)

public plugin_init() {
	
	new PLUGIN[ ] = "Knife Stats";
	new VERSION[ ] = "0.3b";
	new AUTHOR[ ] = "lucas_7_94";

	register_plugin(PLUGIN, VERSION, AUTHOR);
	
	new szInvalidsMaps[ ][ ] =
	{
		"35hp_2",
		"fy_poolday"
	};

	new MapName[ 64 ];
	get_mapname( MapName, 63 );
	
	new i = 0;
	
	for( ; i < sizeof szInvalidsMaps; i++ )
	{
		if( !( isValidMap = bool:!!strcmp( szInvalidsMaps[ i ] , MapName ) )  )
			break;
		
	}

	MySQLx_Init( );
	
	register_clcmd( "say /my_knife", "clcmd_knifestats" );
	register_clcmd( "say /top15_knife", "clcmd_top15knife" );
	
	if( isValidMap )
	{
		iMaxPlayers = get_maxplayers( );
		register_event( "DeathMsg" , "fw_EvDeathMsg_Knife" , "a" , "1>0" , "4&knife");
	}
	else
		server_print("Stats & Count kills with knife disabled! Reason : %s is not a valid map !", szInvalidsMaps[ i ]);

}

public client_putinserver( index ) 
{
	get_user_authid( index , gPlayerAuthid[ index ], charsmax( gPlayerAuthid[ ] ) ) ;
	
	gPlayerConnected SetBit( index );
	
	do_sql_consult( index, 3 );
}

public fw_EvDeathMsg_Knife()
{
	KillsCount[ read_data( 1 ) ]++;
}

public clcmd_knifestats( id )
{
	client_print( id, print_chat, "* You killed %d enemies with knife!", KillsCount[ id ]);
	return PLUGIN_HANDLED;
}
	
public clcmd_top15knife( index )
{	
	ePlayerData[ index ] = STATS;
	do_sql_consult( index, 2);
}


public client_disconnect( id )
{
	if( isValidMap )
	{
		gPlayerConnected RemBit( id );
		do_sql_consult( id , 1 );
		
		SetDefaultValue(id);
	}
}

public MySQLx_Init( )
{
	new const Host[ ] = "localhost";
	new const User[ ] = "root";
	new const Pass[ ] = "";
	new const Data[ ] = "";
	
	g_hTuple = SQL_MakeDbTuple( Host, User, Pass, Data );
	
	if( !g_hTuple ) 
		return pause( "a" );
	
	return PLUGIN_CONTINUE;
}

public plugin_end( ) 
{
	if( isValidMap )
	{
		for( new i = 1 ; i <= iMaxPlayers ; i++ )
		{
			if( gPlayerConnected HasBit( i ) )
			{
				do_sql_consult( i , 1 );
			}
		}
	}
	
	if( g_hTuple )
		SQL_FreeHandle( g_hTuple );
}



do_sql_consult( id, type )
{	
	new eData[ 1 ], String[ 1024 ];
	eData[ 0 ] = id;
		
	/* type :
		1 : Saving
		2 : Stats
		3 : Load 
		4 : Save
	*/
	switch( type )
	{
		case 1: formatex( String, charsmax(String), "INSERT INTO Stats (`User`,`Kills`) VALUES ( ^"%s^", %d );", gPlayerAuthid[ id ], KillsCount[ id ]);
		case 2: formatex( String, charsmax(String), "SELECT * FROM Stats ORDER BY `Stats`.`Kills` DESC LIMIT 15" );
		case 3: formatex( String, charsmax(String), "SELECT * FROM Stats WHERE User=^"%s^";", gPlayerAuthid[ id ] );
		case 4: formatex( String, charsmax(String), "UPDATE Stats SET `Kills`=%d WHERE User='%s';", KillsCount[ id ], gPlayerAuthid[ id ] );
	}
	
	ePlayerData[ id ] = ( type != 4 ) ? type : 1;

	SQL_ThreadQuery( g_hTuple, "MySQL_Handled", String, eData, sizeof eData );
}

public MySQL_Handled( failstate, Handle:Query, error[ ], error2, data[ ], datasize, Float:time )
{
	if( error2 != 1062 ) // Duplicate blablah..
	{
		switch( failstate )
		{
			case TQUERY_CONNECT_FAILED:
			{
				server_print("Error en la conexion al MySQL [%i]: %s", error2, error );
				return PLUGIN_CONTINUE;
			}
			case TQUERY_QUERY_FAILED:
				server_print("Error en la consulta al MySQL [%i]: %s", error2, error );
		}
	}
	
	switch( ePlayerData[ data[ 0 ] ] )
	{
		case STATS:
		{
			new eFieldName = SQL_FieldNameToNum( Query, "User" );
			new eFieldKills = SQL_FieldNameToNum( Query, "Kills" );
			
			new Name[ 33 ];
			
			new gMotd[ 1032 ], len , k;
			new gFrags;
			
			#if defined USING_CUSTOM_MOTD
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "<meta charset=UTF-8><style>body{color:#FFFFFF;background-color:black;margin-top:5;font-family:arial}table{border-collapse:separate;border-spacing:1px;text-align:left;}" );
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "td{font-size:15px;}</style>" );
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "<table border=1 width=700>" );
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "<br><tr bgcolor=##ffffff><td>  #<td>    Name<td>   Kills</tr>");
				
				while( SQL_MoreResults( Query ) )
				{
					SQL_ReadResult( Query, eFieldName, Name, charsmax(Name) );
					gFrags = SQL_ReadResult( Query, eFieldKills );
				
					len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "%s%d", (++k != 1) ? "<tr><td>" : "<tr bgcolor=#00ff00><td>", k);				
					len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "<td>%-22.22s", Name );
					len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "<td>%d", gFrags );
					
					SQL_NextRow( Query ) ;
				}
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "</table></font>" );
			#else
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "<body bgcolor=#000000><font color=#FFB000><pre>" );
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "%s %-22.22s %3s^n", "#", "Name", "Kills");
				
				while( SQL_MoreResults( Query ) )
				{
					SQL_ReadResult( Query, eFieldName, Name, charsmax(Name) );
					gFrags = SQL_ReadResult( Query, eFieldKills );
				
					len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "%d %-22.22s %d^n", ++k , Name, gFrags );
					
					
					SQL_NextRow( Query ) ;
				}
				len += formatex( gMotd[ len ], charsmax( gMotd ) - len, "</body></font></pre>");
			#endif

			show_motd( data[ 0 ] , gMotd, "Knife Stats!" );
		}
		case SAVING:
			if( error2 == 1062 ) /* error 2 is 1062 ( Duplicate entry x for key y ) */
				do_sql_consult( data[ 0 ] , 4 );

		case LOAD:
		{
			if( SQL_NumResults( Query ) >= 1 )
			{
				new eFieldKills = SQL_FieldNameToNum( Query, "Kills" );
				
				KillsCount[ data[ 0 ] ] = SQL_ReadResult( Query, eFieldKills );
			}
			else
			{
				SetDefaultValue( data[ 0 ] );
			}
		}			
	}
	ePlayerData[ data[ 0 ] ] = NULL;
	
	return PLUGIN_CONTINUE;
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang11274\\ f0\\ fs16 \n\\ par }
*/
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ deff0{\\ fonttbl{\\ f0\\ fnil Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang11274\\ f0\\ fs16 \n\\ par }
*/
